<?xml version = "1.0" encoding="UTF-8"?>
<plugin
  id="de.grogra.ext.x3d"
  version="1.6"
  class="de.grogra.ext.x3d.X3DPlugin"
  xmlns="http://grogra.de/registry">

  <import plugin="de.grogra.imp3d"/>
  
  <!-- needed for xmlbeans -->
  <!-- now in platform project
  <library file="jsr173_1.0_api.jar" prefixes="{javax.xml.stream}" />
  <library file="xbean.jar" prefixes="{org.apache.xmlbeans,schemaorg_apache_xmlbeans}" />
  -->
  <library file="x3dxmlbeans.jar" prefixes="{de.grogra.ext.x3d.xmlbeans,schemaorg_apache_xmlbeans}" />
  <library file="X3D.jar" prefixes="{de.grogra.ext.x3d}" />
  
  <registry>
  
    <ref name="io">
      <ref name="filetypes">
        <ext name="x3d" extensions="{.x3d}" mimeType="model/vnd.x3d" />
        <ext name="VRML97" extensions="{.wrl}" mimeType="model/vrml" />
		<ext name="ClassicVRML" extensions="{.x3dv}" mimeType="model/x3d+vrml" />
      </ref>
      
      <ref name="mimetypes">
      
      	<!-- import filter -->
        <mimetype name="model/vnd.x3d">
          <filter 
          		input="reader" 
          		outputClass="de.grogra.graph.impl.Node" 
          		create="de.grogra.ext.x3d.X3DImport"/>
        </mimetype>

        <!-- export filter -->
        <ref name="application/x-java-jvm-local-objectref">
          <filter name="x3d"
            inputClass="de.grogra.imp3d.View3D"
            output="model/vnd.x3d; io=fwriter"
            create="de.grogra.ext.x3d.X3DExport">
            
            <eval name="de.grogra.imp3d.objects.Sphere"
              create="de.grogra.ext.x3d.exportation.SphereExport" />
            <eval name="de.grogra.imp3d.objects.Box"
              create="de.grogra.ext.x3d.exportation.BoxExport" />
            <eval name="de.grogra.imp3d.objects.Cylinder"
              create="de.grogra.ext.x3d.exportation.CylinderExport" />
            <eval name="de.grogra.imp3d.objects.Cone"
              create="de.grogra.ext.x3d.exportation.ConeExport" />
            <eval name="de.grogra.imp3d.objects.Parallelogram"
              create="de.grogra.ext.x3d.exportation.ParallelogramExport"/>
            <eval name="de.grogra.imp3d.objects.Plane"
              create="de.grogra.ext.x3d.exportation.PlaneExport"/>
            <eval name="de.grogra.imp3d.objects.Point"
              create="de.grogra.ext.x3d.exportation.PointExport"/>
            <eval name="de.grogra.imp3d.objects.Line"
              create="de.grogra.ext.x3d.exportation.LineExport"/>
            <eval name="de.grogra.imp3d.objects.Sky"
              create="de.grogra.ext.x3d.exportation.BackgroundExport"/>
          </filter>
          
          <filter name="VRML97"
            inputClass="de.grogra.imp3d.View3D"
            output="model/vrml; io=fwriter"
            create="de.grogra.ext.x3d.VRML97Export">
            
            <eval name="de.grogra.imp3d.objects.Sphere"
              create="de.grogra.ext.x3d.exportation.SphereExport" />
            <eval name="de.grogra.imp3d.objects.Box"
              create="de.grogra.ext.x3d.exportation.BoxExport" />
            <eval name="de.grogra.imp3d.objects.Cylinder"
              create="de.grogra.ext.x3d.exportation.CylinderExport" />
            <eval name="de.grogra.imp3d.objects.Cone"
              create="de.grogra.ext.x3d.exportation.ConeExport" />
            <eval name="de.grogra.imp3d.objects.Parallelogram"
              create="de.grogra.ext.x3d.exportation.ParallelogramExport"/>
            <eval name="de.grogra.imp3d.objects.Plane"
              create="de.grogra.ext.x3d.exportation.PlaneExport"/>
            <eval name="de.grogra.imp3d.objects.Point"
              create="de.grogra.ext.x3d.exportation.PointExport"/>
            <eval name="de.grogra.imp3d.objects.Line"
              create="de.grogra.ext.x3d.exportation.LineExport"/>
            <eval name="de.grogra.imp3d.objects.Sky"
              create="de.grogra.ext.x3d.exportation.BackgroundExport"/>
          </filter>
          
          <filter name="ClassicVRML"
            inputClass="de.grogra.imp3d.View3D"
            output="model/x3d+vrml; io=fwriter"
            create="de.grogra.ext.x3d.ClassicVRMLExport">
            
            <eval name="de.grogra.imp3d.objects.Sphere"
              create="de.grogra.ext.x3d.exportation.SphereExport" />
            <eval name="de.grogra.imp3d.objects.Box"
              create="de.grogra.ext.x3d.exportation.BoxExport" />
            <eval name="de.grogra.imp3d.objects.Cylinder"
              create="de.grogra.ext.x3d.exportation.CylinderExport" />
            <eval name="de.grogra.imp3d.objects.Cone"
              create="de.grogra.ext.x3d.exportation.ConeExport" />
            <eval name="de.grogra.imp3d.objects.Parallelogram"
              create="de.grogra.ext.x3d.exportation.ParallelogramExport"/>
            <eval name="de.grogra.imp3d.objects.Plane"
              create="de.grogra.ext.x3d.exportation.PlaneExport"/>
            <eval name="de.grogra.imp3d.objects.Point"
              create="de.grogra.ext.x3d.exportation.PointExport"/>
            <eval name="de.grogra.imp3d.objects.Line"
              create="de.grogra.ext.x3d.exportation.LineExport"/>
            <eval name="de.grogra.imp3d.objects.Sky"
              create="de.grogra.ext.x3d.exportation.BackgroundExport"/>
          </filter>
        </ref>

      </ref>
    </ref>
    
  </registry>
</plugin>
